Option Explicit

Type L10_WKSTA
    computername            As String
    username                As String
    langroup                As String
    ver_major               As String * 1
    ver_minor               As String * 1
    logon_domain            As String
    other_domains           As String
End Type

Global Const FMT_wksta_info_10 = "P15P20P15B1B1P15P159"

Global L10_WorkstationData      As L10_WKSTA

Declare Function NETAPI_NetWkstaGetInfo Lib "NETAPI.DLL" Alias "NetWkstaGetInfo" (ByVal pszServer As String, ByVal sLevel As Integer, ByVal pbBuffer As Long, ByVal cbBuffer As Integer, pcbTotalAvail As Integer) As Integer

Declare Function VLM_BufferToVBType Lib "VBLANMAN.DLL" Alias "BufferToVBType" (Dest As Any, ByVal DestLen As Integer, ByVal Src As Long, ByVal SrcLen As Integer, ByVal FormatString As String) As Integer
Declare Function VLM_CreateLMBuffer Lib "VBLANMAN.DLL" Alias "CreateLMBuffer" (ByVal FormatString As String, ByVal Entries As Integer, BufferSize As Integer) As Long
Declare Function VLM_FreeLMBuffer Lib "VBLANMAN.DLL" Alias "FreeLMBuffer" (ByVal BufferPointer As Long) As Integer

Function NET_GetWorkstationInfo (tServer As String, L10_Structure As L10_WKSTA, nErrorCode As Integer) As Integer

' Get information about the current workstation.

' Parameter values:
'   tServer         The name of the workstation we want to know about.
'                   If left blank, returns info about the local system.
'   L10_Structure   This is the structure that stores the information.

    Dim lPointer                As Long
    Dim nGlobalSize             As Integer
    Dim nDataBytes              As Integer
    Dim nResult                 As Integer
                                                               
' Set aside global memory to store the workstation information
    lPointer = VLM_CreateLMBuffer(FMT_wksta_info_10, 1, nGlobalSize)
    If lPointer = 0& Then
        NET_GetWorkstationInfo = False
        nErrorCode = 0
        Exit Function
    End If

' Call LM API function NetWkstaGetInfo to get data
    nResult = NETAPI_NetWkstaGetInfo(tServer, 10, lPointer, CLng(nGlobalSize), nDataBytes)
    If nResult = 0 Then
        ' Get the information from the memory structure to pass it back
        nResult = VLM_BufferToVBType(L10_Structure, Len(L10_Structure), lPointer, nGlobalSize, FMT_wksta_info_10)
        ' Determine if a error occurred transferring the information
        If nResult = 0 Then
            NET_GetWorkstationInfo = True
          Else
            NET_GetWorkstationInfo = False
            nErrorCode = nResult
        End If
      Else
        ' An error occrred in the NETAPI.DLL call
        NET_GetWorkstationInfo = False
        nErrorCode = nResult
    End If

    nResult = VLM_FreeLMBuffer(lPointer)            ' Release the memory

End Function

Function UT_ByteToInteger (tChar As String) As Integer

    UT_ByteToInteger = Asc(Left$(tChar, 1))

End Function

