//---------------------------------------------------------------------------
// 					Property information header 
//----------------------------------------------------------------------------


// Convinient macro to find offset of fields in structures
#define OFFSETIN(struc,field)	  ((USHORT)&(((struc *)0)->field))


// Property information to be maintained for each Instance of the control
typedef struct tagINIWIZInfo {
	BOOL 		bNotify;
	HSZ		hszFile;
	HSZ 		hszSection;
	HSZ		hszEntry;
	HSZ		hszValue;
	HSZ		hszAbout;
	WORD		nAction;
}INIWIZINFO;

typedef INIWIZINFO FAR * LPINIWIZINFO;
#define LpIniDEREF(hctl)	((LPINIWIZINFO)VBDerefControl(hctl))


//					The Notify Property - Type : BOOL

PROPINFO Property_Notify  =
    {
    "Notify",
    DT_BOOL | PF_fGetData | PF_fSetData | PF_fSaveData,
    OFFSETIN(INIWIZINFO, bNotify),
    0, 0, NULL, 0
    };

PROPINFO Property_File    =
    {
    "File",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fSaveData,
    OFFSETIN(INIWIZINFO, hszFile ),
    0, 0, NULL, 0
    };

PROPINFO Property_Section =
    {
    "Section",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fSaveData,
    OFFSETIN(INIWIZINFO, hszSection),
    0, 0, NULL, 0
    };

PROPINFO Property_Entry   =
    {
    "Entry",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fSaveData,
    OFFSETIN(INIWIZINFO, hszEntry),
    0, 0, NULL, 0
    };

PROPINFO Property_Value   =
    {
    "Value",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fSaveData,
    OFFSETIN(INIWIZINFO, hszValue),
    0, 0, NULL, 0
    };


PROPINFO Property_Action  =
    {
    "Action",
    DT_SHORT | PF_fNoShow | PF_fGetData | PF_fSetData | PF_fSaveData | PF_fSetMsg ,
    OFFSETIN(INIWIZINFO, nAction),
    0, 0, NULL, 0
    };

enum tagINIOPTIONS {
		INI_READ = 1,
		INI_WRITE,
		INI_DELENTRY,
		INI_DELSECTION
		};

PROPINFO Property_About   =
    {
    "About",
    DT_HSZ | PF_fDefVal | PF_fNoInitDef | PF_fNoRuntimeW | PF_fGetData | PF_fSetData ,
    OFFSETIN(INIWIZINFO, hszAbout ),
    0, 0, NULL, 0
    };


//---------------------------------------------------------------------------
// 									Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_INIWIZ_CTLNAME              0
#define IPROP_INIWIZ_TAG                  1
#define IPROP_INIWIZ_NOTIFY					2
#define IPROP_INIWIZ_FILE						3
#define IPROP_INIWIZ_SECTION					4
#define IPROP_INIWIZ_ENTRY						5
#define IPROP_INIWIZ_VALUE						6
#define IPROP_INIWIZ_ACTION					7
#define IPROP_INIWIZ_ABOUT 					8


PPROPINFO INIWIZ_Properties[] =
    {
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_TAG,
	 &Property_Notify,
	 &Property_File,
	 &Property_Section,
	 &Property_Entry,
	 &Property_Value,
	 &Property_Action,
	 &Property_About,
    NULL
    };
